#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_NewSevenDayCFG.h"
std::auto_ptr<M_NewSevenDayCFG> M_NewSevenDayCFG::msSingleton(nullptr);

int M_NewSevenDayCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_NewSevenDayCFGData* M_NewSevenDayCFG::GetData(int Day)
{
	auto it = mMapData.find(Day);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_NewSevenDayCFGData>& M_NewSevenDayCFG::GetMapData()
{
	return mMapData;
}

void M_NewSevenDayCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_NewSevenDayCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_NewSevenDayCFGData data;
		data.mDay = element->IntAttribute("Day");
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mAccumAwardId = element->IntAttribute("AccumAwardId");
		data.mAccumAwardCount = element->IntAttribute("AccumAwardCount");
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		CCASSERT(mMapData.find(data.mDay) == mMapData.end(), "data.mDay is exists");
		mMapData.insert(std::make_pair(data.mDay, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_NewSevenDayCFG Loaded. Load Data:%u", mMapData.size());
}

void M_NewSevenDayCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_NewSevenDayCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_NewSevenDayCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_NewSevenDayCFGData data;
		LuaCfgHelper::readInt(L, "Day", data.mDay);
		LuaCfgHelper::readVectorInt(L, "AwardItemIDs", data.mAwardItemIDs);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readInt(L, "AccumAwardId", data.mAccumAwardId);
		LuaCfgHelper::readInt(L, "AccumAwardCount", data.mAccumAwardCount);
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		CCASSERT(mMapData.find(data.mDay) == mMapData.end(), "data.mDay is exists");
		mMapData.insert(std::make_pair(data.mDay, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_NewSevenDayCFG Loaded. Load Data:%u", mMapData.size());
}

void M_NewSevenDayCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_NewSevenDayCFG* M_NewSevenDayCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_NewSevenDayCFG());
	}
	return msSingleton.get();
}

void M_NewSevenDayCFG::Release()
{
	msSingleton.reset(nullptr);
}
